<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="菜单名称" prop="menuName">
        <el-input
          v-model="queryParams.menuName"
          placeholder="请输入菜单名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="菜单标识" prop="menuIdenti">
        <el-input
          v-model="queryParams.menuIdenti"
          placeholder="请输入菜单标识"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="菜单图片" prop="menuImg">
        <el-input
          v-model="queryParams.menuImg"
          placeholder="请输入菜单图片"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="菜单地址" prop="menuUrl">
        <el-input
          v-model="queryParams.menuUrl"
          placeholder="请输入菜单地址"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="删除状态" prop="delFlag">
        <el-input
          v-model="queryParams.delFlag"
          placeholder="请输入删除状态"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['wxsetting:wxMenConfig:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['wxsetting:wxMenConfig:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['wxsetting:wxMenConfig:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['wxsetting:wxMenConfig:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="wxMenConfigList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="${comment}" align="center" prop="id" />
      <el-table-column label="菜单名称" align="center" prop="menuName" />
      <el-table-column label="菜单标识" align="center" prop="menuIdenti" />
      <el-table-column label="菜单图片" align="center" prop="menuImg" />
      <el-table-column label="菜单地址" align="center" prop="menuUrl" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['wxsetting:wxMenConfig:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['wxsetting:wxMenConfig:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改菜单配置对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="菜单名称" prop="menuName">
          <el-input v-model="form.menuName" placeholder="请输入菜单名称" />
        </el-form-item>
        <el-form-item label="菜单标识" prop="menuIdenti">
          <el-input v-model="form.menuIdenti" placeholder="请输入菜单标识" />
        </el-form-item>
        <el-form-item label="菜单图片" prop="menuImg">
          <el-input v-model="form.menuImg" placeholder="请输入菜单图片" />
        </el-form-item>
        <el-form-item label="菜单地址" prop="menuUrl">
          <el-input v-model="form.menuUrl" placeholder="请输入菜单地址" />
        </el-form-item>
        <el-form-item label="删除状态" prop="delFlag">
          <el-input v-model="form.delFlag" placeholder="请输入删除状态" />
        </el-form-item>
        <el-divider content-position="center">菜单配置角色信息</el-divider>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" icon="el-icon-plus" size="mini" @click="handleAddSurMenuConfigRole">添加</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" icon="el-icon-delete" size="mini" @click="handleDeleteSurMenuConfigRole">删除</el-button>
          </el-col>
        </el-row>
        <el-table :data="surMenuConfigRoleList" :row-class-name="rowSurMenuConfigRoleIndex" @selection-change="handleSurMenuConfigRoleSelectionChange" ref="surMenuConfigRole">
          <el-table-column type="selection" width="50" align="center" />
          <el-table-column label="序号" align="center" prop="index" width="50"/>
          <el-table-column label="角色主键" prop="roleId" width="150">
            <template slot-scope="scope">
              <el-input v-model="scope.row.roleId" placeholder="请输入角色主键" />
            </template>
          </el-table-column>
        </el-table>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listWxMenConfig, getWxMenConfig, delWxMenConfig, addWxMenConfig, updateWxMenConfig } from "@/api/wxsetting/wxMenConfig";

export default {
  name: "WxMenConfig",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 子表选中数据
      checkedSurMenuConfigRole: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 菜单配置表格数据
      wxMenConfigList: [],
      // 菜单配置角色表格数据
      surMenuConfigRoleList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        menuName: null,
        menuIdenti: null,
        menuImg: null,
        menuUrl: null,
        delFlag: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询菜单配置列表 */
    getList() {
      this.loading = true;
      listWxMenConfig(this.queryParams).then(response => {
        this.wxMenConfigList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        menuName: null,
        menuIdenti: null,
        menuImg: null,
        menuUrl: null,
        delFlag: null,
        createTime: null
      };
      this.surMenuConfigRoleList = [];
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加菜单配置";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getWxMenConfig(id).then(response => {
        this.form = response.data;
        this.surMenuConfigRoleList = response.data.surMenuConfigRoleList;
        this.open = true;
        this.title = "修改菜单配置";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.surMenuConfigRoleList = this.surMenuConfigRoleList;
          if (this.form.id != null) {
            updateWxMenConfig(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addWxMenConfig(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除菜单配置编号为"' + ids + '"的数据项？').then(function() {
        return delWxMenConfig(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
	/** 菜单配置角色序号 */
    rowSurMenuConfigRoleIndex({ row, rowIndex }) {
      row.index = rowIndex + 1;
    },
    /** 菜单配置角色添加按钮操作 */
    handleAddSurMenuConfigRole() {
      let obj = {};
      obj.roleId = "";
      this.surMenuConfigRoleList.push(obj);
    },
    /** 菜单配置角色删除按钮操作 */
    handleDeleteSurMenuConfigRole() {
      if (this.checkedSurMenuConfigRole.length == 0) {
        this.$modal.msgError("请先选择要删除的菜单配置角色数据");
      } else {
        const surMenuConfigRoleList = this.surMenuConfigRoleList;
        const checkedSurMenuConfigRole = this.checkedSurMenuConfigRole;
        this.surMenuConfigRoleList = surMenuConfigRoleList.filter(function(item) {
          return checkedSurMenuConfigRole.indexOf(item.index) == -1
        });
      }
    },
    /** 复选框选中数据 */
    handleSurMenuConfigRoleSelectionChange(selection) {
      this.checkedSurMenuConfigRole = selection.map(item => item.index)
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('wxsetting/wxMenConfig/export', {
        ...this.queryParams
      }, `wxMenConfig_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
